<?
  // This function retrieve the already done groups and return the html for displaing it.
  // $type: the group type
  // $js: a return variable that contains the javascript for the ajax function
  // RETURN: this function return the html for display the groups
  
  function listGroup($type,&$js,$groups=null) {
    global $asterisk,$relBasePath,$cwlang;
    $ret=$asterisk->getGroup(0,$type);
    if ($err=$asterisk->getError()) die("Error: $err");
    $count=0;
    
    if (is_array($ret))
    foreach($ret as $v) {
      $id=$v["id"];
      $name=$v["name"];
      $type=$v["type"];
      if ($type==GROUP_OF_CLIENT)     $prot="<img src=\"$relBasePath/public/img/client.gif\" alt=\"client\" />";
      if ($type==GROUP_OF_DEPARTMENT) $prot="<img src=\"$relBasePath/public/img/dep.gif\" alt=\"department\" />";
      if ($type==GROUP_OF_RESOURCE)   $prot="<img src=\"$relBasePath/public/img/res.gif\" alt=\"resource\" />";
      if ($type==GROUP_OF_PHONENUMBER)$prot="<img src=\"$relBasePath/public/img/number.gif\" alt=\"Phone Number\" />";
      if (is_array($groups)) {
        if (in_array($id, $groups ) ) $checked=" checked=\"checked\"";
        else $checked="";
      } else $checked="";
      $html.="<div class=\"groupItem\"> <input type=\"checkbox\" name=\"group[]\" value=\"$id\" $checked/>$prot $name </div>\n";
      if ((++$count)%2==0) $html.="</tr><tr>\n";
    }
    
    //------------------------------   CLIENT SIDE    --------------------------
    
    //html code
    ob_start()
    ?>
    	<h2><?=$cwlang["group"]["title"]?></h2>
      <p class="blockintro">
        <?=$cwlang["group"]["chooseGroup"]?>
        (<a href="<?=$PHP_SELF?>" onclick="if (groupName=prompt('Name','gruppo'+Math.round(Math.random()*1000))) {do_addGroup(groupName,<?=$type?>); return false;}" class="admin" ><?=$cwlang["group"]["newGroup"]?></a>)
      </p>
      <div class="block">
        <div id="groupTable"><?=$html?></div><div id="groupStatus"></div>
        <div style="clear: both"></div> 
      </div>
    <?
    $contents=ob_get_contents();
    ob_end_clean();

    //javascript code
  	ob_start();
      ?>
    	function do_addGroup_cb(groupArray) {
        
        var groupName=groupArray["name"];
        var groupId=groupArray["id"];
        var groupIcon=groupArray["icon"];

        document.getElementById("groupStatus").innerHTML="";
        
        var groupList=document.getElementById("groupTable");
        var oNewNode = document.createElement("DIV");
        oNewNode.className="groupItem";
        oNewNode.innerHTML="<input type=\"checkbox\" name=\"group[]\" value=\"" + groupId + "\"/> " + groupIcon + " " + groupName ;
        groupList.appendChild(oNewNode);
        
    	}
    	
    	function do_addGroup(groupName,type) {
        document.getElementById("groupStatus").innerHTML="<img src='<?=$relBasePath?>/public/img/ico-progress.gif' > <?=$cwlang["generic"]["working"]?>";
        x_addGroup(groupName, type, do_addGroup_cb);    		
    	}
      <?

    $js.=ob_get_contents();
    ob_end_clean();


    //------------------------------   SERVER SIDE    --------------------------
  	function addGroup($groupName,$type) {
      global $relBasePath,$asterisk;
      if ($type==GROUP_OF_CLIENT)     $prot="<img src=\"$relBasePath/public/img/client.gif\" alt=\"client\" />";
      if ($type==GROUP_OF_DEPARTMENT) $prot="<img src=\"$relBasePath/public/img/dep.gif\" alt=\"department\" />";
      if ($type==GROUP_OF_RESOURCE)   $prot="<img src=\"$relBasePath/public/img/res.gif\" alt=\"resource\" />";
      if ($type==GROUP_OF_PHONENUMBER)$prot="<img src=\"$relBasePath/public/img/number.gif\" alt=\"Phone Number\" />";

      $entry=Array("type" => $type, "name" => $groupName );
      $result=$asterisk->putGroup($entry);
      if ($result>0) {
        $ret["id"]=$result;
        $ret["name"]=$groupName;
        $ret["icon"]=$prot;
      } else {
        $ret["id"]=0;
      }

      return $ret;
  	}

  	sajax_export("addGroup");
    return $contents;
  }
  
  //----------------------------------------------------------------------------
  
  // This function retrieve the already done rights and return the html for displaing it.
  // $js: a return variable that contains the javascript for the ajax function
  // $rights: an input parameter for the already selected rights
  // RETURN: this function return the html for display the rights
  
  function listRight(&$js,$rights=null) {
    global $asterisk,$relBasePath,$cwlang;
    $ret=$asterisk->getRight(0);
    if ($err=$asterisk->getError()) die("Error: $err");
    $count=0;
    
    if (is_array($ret))
    foreach($ret as $v) {
      $id=$v["id"];
      $name=$v["name"];
      if ($name==$rights) $checked=" checked=\"checked\"";
      else $checked="";
      $html.="<div class=\"groupItem\"> <input type=\"radio\" name=\"right\" value=\"$name\" $checked/> $name </div>\n";
      if ((++$count)%2==0) $html.="</tr><tr>\n";
    }
    
    //------------------------------   CLIENT SIDE    --------------------------
    
    //html code
    ob_start()
    ?>
    	<h2><?=$cwlang["right"]["title"]?></h2>
      <p class="blockintro">
        <?=$cwlang["right"]["chooseRight"]?>
        (<a href="<?=$PHP_SELF?>" onclick="if (rightName=prompt('Name','diritto'+Math.round(Math.random()*1000))) {do_addRight(rightName); return false;}" class="admin" ><?=$cwlang["right"]["newRight"]?></a>)
      </p>
      <div class="block">
        <div id="rightTable"><?=$html?></div><div id="rightStatus"></div>
        <div style="clear: both"></div> 
      </div>
    <?
    $contents=ob_get_contents();
    ob_end_clean();

    //javascript code
  	ob_start();
      ?>
    	function do_addRight_cb(rightArray) {
        var rightName=rightArray["name"];
        var rightId=rightArray["id"];

        document.getElementById("rightStatus").innerHTML="";
        
        var rightList=document.getElementById("rightTable");
        var oNewNode = document.createElement("DIV");
        oNewNode.className="groupItem";
        oNewNode.innerHTML="<input type=\"radio\" name=\"right\" value=\"" + rightName + "\"/> " + rightName ;
        rightList.appendChild(oNewNode);
    	}
    	
    	function do_addRight(rightName) {
        document.getElementById("rightStatus").innerHTML="<img src='<?=$relBasePath?>/public/img/ico-progress.gif' > <?=$cwlang["generic"]["working"]?>";
        x_addRight(rightName, do_addRight_cb);    		
    	}
      <?

    $js.=ob_get_contents();
    ob_end_clean();


    //------------------------------   SERVER SIDE    --------------------------
  	function addRight($rightName) {
      global $relBasePath,$asterisk;

      $entry=Array("name" => $rightName );
      $result=$asterisk->putRight($entry);
      if ($result>0) {
        $ret["id"]=$result;
        $ret["name"]=$rightName;
      } else {
        $ret["id"]=0;
      }

      return $ret;
  	}

  	sajax_export("addRight");
    
    return $contents;
  }  


  //----------------------------------------------------------------------------
  
  // This function retrieve the already done rights and return the html for displaing it.
  // $js: a return variable that contains the javascript for the ajax function
  // $rights: an array (for input) for the already selected rights
  // RETURN: this function return the html for display the rights
  
  function listRightCheckBox(&$js,$rights=null) {
    global $asterisk,$relBasePath,$cwlang;
    $ret=$asterisk->getRight(0);
    if ($err=$asterisk->getError()) die("Error: $err");
    $count=0;
    
    if (is_array($ret))
    foreach($ret as $v) {
      $id=$v["id"];
      $name=$v["name"];
      if (is_array($rights)) {
        if (in_array($id, $rights ) ) $checked=" checked=\"checked\"";
        else $checked="";
      } else $checked="";
      $html.="<div class=\"groupItem\"> <input type=\"checkbox\" name=\"right[]\" value=\"$id\" $checked/> $name </div>\n";
      if ((++$count)%2==0) $html.="</tr><tr>\n";
    }
    
    //------------------------------   CLIENT SIDE    --------------------------
    
    //html code
    ob_start()
    ?>
    	<h2><?=$cwlang["right"]["title"]?></h2>
      <p class="blockintro">
        <?=$cwlang["right"]["chooseRight"]?>
        (<a href="<?=$PHP_SELF?>" onclick="if (rightName=prompt('name','diritto'+Math.round(Math.random()*1000))) {do_addRight(rightName); return false;}" class="admin" ><?=$cwlang["right"]["newRight"]?></a>)
      </p>
      <div class="block">
        <div id="rightTable"><?=$html?></div>
        <div style="clear: both"></div> 
      </div>
    <?
    $contents=ob_get_contents();
    ob_end_clean();

    //javascript code
  	ob_start();
      ?>
    	function do_addRight_cb(rightArray) {
        var rightName=rightArray["name"];
        var rightId=rightArray["id"];
        
        var rightList=document.getElementById("rightTable");
        var oNewNode = document.createElement("DIV");
        oNewNode.className="groupItem";
        oNewNode.innerHTML="<input type=\"checkbox\" name=\"right[]\" value=\"" + rightId + "\"/> " + rightName ;
        rightList.appendChild(oNewNode);
    	}
    	
    	function do_addRight(rightName) {
        x_addRight(rightName, do_addRight_cb);    		
    	}
      <?

    $js.=ob_get_contents();
    ob_end_clean();


    //------------------------------   SERVER SIDE    --------------------------
  	function addRight($rightName) {
      global $relBasePath,$asterisk;

      $entry=Array("name" => $rightName );
      $result=$asterisk->putRight($entry);
      if ($result>0) {
        $ret["id"]=$result;
        $ret["name"]=$rightName;
      } else {
        $ret["id"]=0;
      }

      return $ret;
  	}

  	sajax_export("addRight");
    
    return $contents;
  }  

  


  
  
  
  
  
  
  //----------------------------------------------------------------------------
  
  // This function retrieve the already done rights and return the html for displaing it.
  // $js: a return variable that contains the javascript for the ajax function
  // $rights: an input parameter for the already selected rights
  // RETURN: this function return the html for display the rights
  
  function manageNode(&$js) {
    global $asterisk,$relBasePath,$cwlang;

    $ivr=$asterisk->getIvr($_REQUEST["choosedIvr"]);
    $ivr_id=$ivr[0]["id"];    
    $rootNode=$ivr[0]["rootnode"];
    $rootName=$ivr[0]["name"];
    if ($ivr_id=="") return;
    $nodeArray=$asterisk->getIvrNode($rootNode,true);
    $html=writeTree($nodeArray,$rootNode);
    //------------------------------   CLIENT SIDE    --------------------------
    
    //html code
    ob_start()
    ?>
          <h1><?=$cwlang["ivr"]["title"]?></h1>
          <div id="tree"></div>        
          <script>
            if (document.getElementById) {
              var selected=null;
            	//var node_<?=$rootNode?> = new WebFXTree("<a href=\"javascript: webFXTreeHandler.focus(document.getElementById('node_<?=$rootNode?>')); do_loadPane('<?=$rootNode?>'); \"><img src='../../admin/public/img/edit.gif' /></a> " + "<?=$rootName?>",'javascript: do_addButton(<?=$rootNode?>)');
            	var node_<?=$rootNode?> = new WebFXTree("<?=$rootName?>",'javascript: do_addButton(<?=$rootNode?>)');
              node_<?=$rootNode?>.nodeId=<?=$rootNode?>;
            	node_<?=$rootNode?>.setBehavior('classic');
              <?=$html?>
              
              document.getElementById("tree").innerHTML=node_<?=$rootNode?>.toString();
              node_<?=$rootNode?>.expandAll();
              if (selected!=null) selected.focus();
              else node_<?=$rootNode?>.focus();
              if (node_<?=$rootNode?>.getSelected()==node_<?=$rootNode?>) {do_addButton(<?=$rootNode?>);}
            }
          </script>
    
          <br />
          <!--
          <input type="button" onclick="if (newNode=prompt('Nuova voce')) do_addIvrNode(newNode);"  style="width: 80px;" value="Aggiungi" />
          <input type="button" onclick="do_delNode();"   style="width: 80px;" value="Elimina " /><br />
          -->
          <input type="button" onclick="do_buildIvr();"   style="width: 166px;" value="<?=$cwlang["ivr"]["apply"]?>" /><br />
          
          
    <?
    $contents=ob_get_contents();
    ob_end_clean();

    //javascript code
  	ob_start();
      ?>
    	function do_addIvrNode_cb(nodeArray) {
      	if (node_<?=$rootNode?>.getSelected()) {
          var nodeName=nodeArray["name"];
          var nodeId=nodeArray["id"];
          var newNode=new WebFXTreeItem(nodeName, "javascript: do_addButton("+nodeId+")");
      		node_<?=$rootNode?>.getSelected().add(newNode);
          newNode.nodeId=nodeId;
          
          newNode.focus();
          do_loadPane(nodeId);
          Fat.fade_element(node_<?=$rootNode?>.getSelected().id, 30, 300, "#FFFF33", "#FFFFFF");
      	}
    	}
    	function do_addIvrNode(nodeName) {
      	if (node_<?=$rootNode?>.getSelected()) {
          var nodeParent=node_<?=$rootNode?>.getSelected().nodeId;      
          document.getElementById("editPane").innerHTML="<img src='<?=$relBasePath?>/public/img/ico-progress.gif' > <?=$cwlang["generic"]["working"]?>";
          var params = new Array();
          params[0]=nodeName;
          params[1]=nodeParent;
          x_addIvrNode(params, do_addIvrNode_cb);    		
        }
    	}

    	function do_delNode_cb(node) {
        	if (node_<?=$rootNode?>.getSelected()) {
        		node_<?=$rootNode?>.getSelected().remove();
            document.getElementById("editPane").innerHTML="<img src=\"<?=$relBasePath?>/public/img/ok.gif\"> <?=$cwlang["ivr"]["nodeDeleted"]?>";
        	}
    	}
    	function do_delNode() {
      	if (node_<?=$rootNode?>.getSelected()) {
          document.getElementById("editPane").innerHTML="<img src='<?=$relBasePath?>/public/img/ico-progress.gif' > <?=$cwlang["generic"]["deleting"]?>";
          //if (node_<?=$rootNode?>.getSelected().nodeId==1) {
          if (node_<?=$rootNode?>.getSelected()==node_<?=$rootNode?>) {
            alert("Impossibile eliminare il nodo radice");
            document.getElementById("editPane").innerHTML="<img src=\"<?=$relBasePath?>/public/img/ok.gif\"> <?=$cwlang["ivr"]["nodeNotDeleted]"]?>";
          } else x_delNode(node_<?=$rootNode?>.getSelected().nodeId, do_delNode_cb);    		
      	} else alert("Seleziona un nodo da eliminare");
    	}
      
      function do_loadPane_cb(html) {
        if (document.getElementById("alert")) document.getElementById("alert").style.display="none";
        document.getElementById("editPane").innerHTML=html;
        Fat.fade_element("basic_form", 30, 300, "#FFFF33", "#FFFFFF");
      }
      function do_loadPane(nodeId) {
        document.getElementById("editPane").innerHTML="<img src='<?=$relBasePath?>/public/img/ico-progress.gif' > <?=$cwlang["generic"]["loading"]?>";
        x_loadPane(nodeId, do_loadPane_cb);
      }

      function do_buildIvr_cb() {
        if (document.getElementById("alert")) document.getElementById("alert").style.display="none";
        document.getElementById("editPane").innerHTML="<strong><?=$cwlang["ivr"]["created"]?></strong>";
        Fat.fade_element("editPane", 30, 300, "#FFFF33", "#FFFFFF");
      }
      function do_buildIvr() {
        document.getElementById("editPane").innerHTML="<img src='<?=$relBasePath?>/public/img/ico-progress.gif' > <?=$cwlang["ivr"]["creating"]?>";
        x_buildIvr(<?=$ivr_id?>,do_buildIvr_cb);
      }
      
      function do_addButton(nodeId) {
        if (node_<?=$rootNode?>.getSelected()) {
          var txt=
            "<div id='nodeActions'>" +
            "<?=$cwlang["ivr"]["chooseAction"]?>:" +
            "<ul>" +
            "<li><img src='<?=$relBasePath?>/public/img/add.gif' > <a href=\"javascript: if (newNode=prompt('Node name', 'node'+Math.round(Math.random()*1000) )) do_addIvrNode(newNode);\"><?=$cwlang["ivr"]["newNode"]?></a></li>" +
            "<li><img src='<?=$relBasePath?>/public/img/edit.gif' > <a href=\"javascript: do_loadPane('"+nodeId+"')\"><?=$cwlang["ivr"]["modNode"]?></a></li>";
          if (node_<?=$rootNode?>.getSelected()!=node_<?=$rootNode?>) 
          txt+="<li><img src='<?=$relBasePath?>/public/img/trash.gif'> <a href=\"javascript: if (confirm('Are you sure to delete the selected node?')) do_delNode('"+nodeId+"')\"><?=$cwlang["ivr"]["delNode"]?></a></li>";
          txt+="</ul></div>";
          document.getElementById("editPane").innerHTML=txt;
          Fat.fade_element("nodeActions", 30, 300, "#FFFF33", "#FFFFFF");
        }
      }

      <?

    $js.=ob_get_contents();
    ob_end_clean();


    //------------------------------   SERVER SIDE    --------------------------
  	function addIvrNode($params) {
      global $relBasePath,$asterisk;
      //retrieve the params from the comma separated list (params = foo,1)
      $arrParams=split(",",$params);
      $nodeName=$arrParams[0];
      $nodeParent=$arrParams[1];
      
      $entry=Array("name" => $nodeName, "parent" => $nodeParent );
      $result=$asterisk->putIvrNode($entry);
      if ($result>0) {
        $ret["id"]=$result;
        $ret["name"]=$nodeName;
      } else {
        $ret["id"]=0;
      }
      return $ret;
  	}
  	function delNode($nodeId) {
      global $relBasePath,$asterisk;

      $result=$asterisk->delIvrNode($nodeId);
      return $result;
  	}
    
    function loadPane($nodeId) {
      ob_start();
        include("edit.php");
      $contents=ob_get_contents();
      ob_end_clean();
      return $contents;
    }

    function buildIvr($ivr_id) {
      global $asterisk;
      $ret=$asterisk->compileIvr($ivr_id);
      return 1;
    }

  	sajax_export("addIvrNode");
  	sajax_export("delNode");
  	sajax_export("loadPane");
  	sajax_export("buildIvr");

    return $contents;
  }  
  
    function writeTree($nodeArray,$id=1,$ret="") {
      $return="";
      $postdata=$_POST["node"];
      $selected=$postdata["id"];
      foreach ($nodeArray as $n) {
        if ($n["parent"]==$id) {
          $nodeId=$n["id"];
          $nodeName=$n["name"];
          $nodeKey=$n["key"];
          if ($nodeKey!="") $key="$nodeKey - "; else $key="";
          $tmpVar="node_".$nodeId;
          $parentName="node_".$id;
          //$return.= "     var $tmpVar = new WebFXTreeItem(\"".$key.$nodeName."\",'javascript:do_loadPane(".$nodeId.")');\n" ;
          $return.= "     var $tmpVar = new WebFXTreeItem(\"".$key.$nodeName." \",'javascript:do_addButton(".$nodeId.")');\n" ;
          $return.= "     $tmpVar.nodeId=$nodeId;\n" ;
          $return.= "    	$parentName.add($tmpVar);\n" ;
          if ($n["id"]==$selected) $return.= "    	selected=".$tmpVar."; \n" ;
          $return.= writeTree($nodeArray,$nodeId,$ret);
        }
      }
      return $ret.$return;
    }


    
  function getOption($type,$userValue=null) {
    global $asterisk;
    $ret=$asterisk->getOption(0,$type);
    if ($err=$asterisk->getError()) die("Error: $err");
    if (is_array($ret)) {
      foreach($ret as $v) {
        $element="";
        $id=$v["id"];
        $name=$v["name"];
        $value=$v["value"];
        $valuelist=$v["valuelist"];
        $default=$v["default"];
        $type=$v["type"];
        $comment=nl2br($v["comment"]);
        $commented=$v["commented"];
  
        if ($value=="") $v=$default; else $v=$value;
        if (is_array($userValue)) foreach($userValue as $uv) if ($uv["id"]==$id) $v=$uv["value"];
        if ($commented=="1") {
          $element=$v."<input type=\"hidden\" name=\"$id\" value=\"\" />";
          $type="none";
          $chkCommented=" checked=\"checked\" ";
        } else $chkCommented="";
        

        switch ($type) {
          case "textfield":
            $element.="<input type=\"text\" size=\"25\" maxlength=\"30\" id=\"$name\" name=\"$id\" value=\"$v\" $disabled />";
          break;
          case "check":
            $arr=split(",",$valuelist);
            foreach($arr as $item) {
              $item=trim($item);
              if ($item==$v) $checked=" checked=\"checked\" "; else $checked="";
              if ($item==$default) $d=" (default) "; else $d=""; 
              $element.="<input type=\"checkbox\" id=\"$name\" name=\"$id\" value=\"$item\" $checked  $disabled/> $item $d";
            }
          break;
          case "radio":
            $arr=split(",",$valuelist);
            foreach($arr as $item) {
              $item=trim($item);
              if ($item==$v) $checked=" checked=\"checked\" "; else $checked="";
              if ($item==$default) $d=" (default) "; else $d=""; 
              $element.="<input type=\"radio\" id=\"$name\" name=\"$id\" value=\"$item\" $checked  $disabled/> $item $d";
            }
          break;
          case "select":
            $arr=split(",",$valuelist);
            $element="<select name=\"$id\" id=\"$name\"  $disabled >";
            foreach($arr as $item) {
              $item=trim($item);
              if ($item==$v) $checked=" selected=\"selected\" "; else $checked="";
              if ($item==$default) $d=" (default) "; else $d=""; 
              $element.="<option value=\"".trim($item)."\" $checked/> $item $d</option>";
            }
          break;
        }
        $name=UCfirst(str_replace("_"," ",$name));
        $checkboxCommented="<input type=\"checkbox\" name=\"cw_comment_option[$id]\" value=\"1\" $chkCommented /> ";

        $html.= "      <tr>\n" ;
        if ($commented=="1") $html.= "        <td style='border-bottom: 1px dotted gray;'>$checkboxCommented $name:</td>\n" ;
        else $html.= "        <td style='border-bottom: 1px dotted gray;'>$checkboxCommented <label for=\"dep[name]\" class=\"required\">$name:</label></td>\n" ; 
        $html.= "        <td >$element </td>\n" ;
        $html.= "      </tr>\n" ;
        if ($commented=="0") $html.= "      <tr><td colspan=\"2\" class=\"help\">$comment</td></tr>\n" ;
        $html.= "      <tr><td colspan=\"2\" class=\"help\"><br/></td></tr>\n" ;
      }
    }  

    return $html;
  }    
  
/*******************************************************************************
****************      Go To Main Page *****************************************/
  function goToMainPage($alert,$page="") {
    session_start();
    $_SESSION['alert']=$alert;
    if ($page=="") header("location: ../");
    else header("location: $page");
    return;
  }

  function getAlert() {
    session_start();
    $alert=$_SESSION['alert'];
    unset($_SESSION['alert']);
    return $alert;
  }
  
/*******************************************************************************
****************      User informations *****************************************/

  function checkUser($username, $password) {
    global $asterisk;
    $result=$asterisk->checkUser($username,md5($password));
    return $result;
	}
  
  function getAvailLang() {
    global $absBasePath;
    if ($handle = opendir($absBasePath."public/lang")) {
       while (false !== ($file = readdir($handle))) { 
           if ($file != "." && $file != ".." and substr($file,-4,4)==".php") { 
               $ret[]=substr($file,0,strlen($file)-4); 
           } 
       }
       closedir($handle); 
    }
    return $ret;
	}
  
  
/*******************************************************************************
*****************     Create an Html Version of Action ************************/

  function getHtmlAction($nid,$action,$action_option) {//,$act,$grp,$que,$ivr) {
    global $asterisk,$cwlang;
  
    //select the available action
    $act=$asterisk->getAction(0);
    if ($err=$asterisk->getError()) die("Error: $err");
  
    //select the available extension group
    $grp=$asterisk->getGroup(0,GROUP_OF_CLIENT);
    if ($err=$asterisk->getError()) die("Error: $err");
    
    //select the available queue
    $que=$asterisk->getQueue(0);
    if ($err=$asterisk->getError()) die("Error: $err");
  
    //select the available ivr
    $ivr=$asterisk->getIvr(0);
    if ($err=$asterisk->getError()) die("Error: $err");
  
    if (is_array($grp)) foreach($grp as $a) {
      if ($a["id"]==$action_option and $action==ACTION_GROUP) $selected=" selected=\"selected\" "; else $selected="";
      $option[ACTION_GROUP].="<option value=\"".$a["id"]."\" $selected>".$a["name"]."</option>";
    }
    $option[ACTION_GROUP]="<select $display name=\"action_option[$nid][".ACTION_GROUP."]\" id=\"opt".$nid."-".ACTION_GROUP."\" ><option></option>".$option[ACTION_GROUP]."</select>";
    
    if (is_array($que)) foreach($que as $a) {
      if ($a["id"]==$action_option and $action==ACTION_QUEUE) $selected=" selected=\"selected\" "; else $selected="";
      $option[ACTION_QUEUE].="<option value=\"".$a["id"]."\" $selected>".$a["name"]."</option>";
    }
    $option[ACTION_QUEUE]="<select $display name=\"action_option[$nid][".ACTION_QUEUE."]\" id=\"opt".$nid."-".ACTION_QUEUE."\"><option></option>".$option[ACTION_QUEUE]."</select>";

    if (is_array($ivr)) foreach($ivr as $a) {
      if ($a["id"]==$action_option and $action==ACTION_IVR) $selected=" selected=\"selected\" "; else $selected="";
      $option[ACTION_IVR].="<option value=\"".$a["id"]."\" $selected>".$a["name"]."</option>";
    }
    $option[ACTION_IVR]="<select $display name=\"action_option[$nid][".ACTION_IVR."]\"  id=\"opt".$nid."-".ACTION_IVR."\"><option></option>".$option[ACTION_IVR]."</select>";

    
    //no choose
    $actionAvailable.="<tr><td class=\"actionTableLabel\">\n";
    if ($action==0) $checked=" checked=\"checked\" "; else $checked="";
    $actionAvailable.="<input type=\"radio\" name=\"action[".$nid."]\" value=\"0\" $checked> No Action \n";
    $actionAvailable.="</td></tr> \n";

    if (is_array($act)) 
    foreach($act as $a) {
      $actionAvailable.="<tr><td class=\"actionTableLabel\">\n";
      if ($a["id"]==$action) $checked=" checked=\"checked\" "; else $checked="";
      $actionAvailable.="<input type=\"radio\" name=\"action[".$nid."]\" value=\"".$a["id"]."\" $checked>".$a["name"]." \n";
      
      $actionAvailable.="</td><td class=\"actionTableValue\">\n";
      if (isset($option[$a["id"]])) $actionAvailable.=$option[$a["id"]]."\n";
      //else $actionAvailable.="<input type=\"text\"  name=\"action_option[$nid][".$a["id"]."]\"  id=\"opt$group-".$a["id"]."\"/>\n";
      $actionAvailable.="</td></tr>\n";
    }

    //$html=" <span style='margin-left: 30px;' > \n";
    $html.=" <table class=\"actionTable\">$actionAvailable</table>";
    //$html.=" </span> \n";
    return $html;    
  } //end of function
  
?>